VERSION 5.00
Begin VB.Form frmShip 
   AutoRedraw      =   -1  'True
   BackColor       =   &H00000000&
   Caption         =   "FPS: 0"
   ClientHeight    =   5700
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6195
   LinkTopic       =   "Form1"
   ScaleHeight     =   380
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   413
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "frmShip"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'**************************************************************
'
' THIS WORK, INCLUDING THE SOURCE CODE, DOCUMENTATION
' AND RELATED MEDIA AND DATA, IS PLACED INTO THE PUBLIC DOMAIN.
'
' THE ORIGINAL AUTHOR IS RYAN CLARK.
'
' THIS SOFTWARE IS PROVIDED AS-IS WITHOUT WARRANTY
' OF ANY KIND, NOT EVEN THE IMPLIED WARRANTY OF
' MERCHANTABILITY. THE AUTHOR OF THIS SOFTWARE,
' ASSUMES _NO_ RESPONSIBILITY FOR ANY CONSEQUENCE
' RESULTING FROM THE USE, MODIFICATION, OR
' REDISTRIBUTION OF THIS SOFTWARE.
'
'**************************************************************
'
' This file was downloaded from The Game Programming Wiki. Come
' and visit us at http://gpwiki.org
'
'**************************************************************

Option Explicit

'The gettickcount API delcaration
Private Declare Function GetTickCount Lib "kernel32" () As Long

Const PI = 3.14159          'Mmmm.. Pi
Const ACCEL = 0.00025       'Rate of increase of speed
Const ROTATION_RATE = 0.5   'Rotation speed
Const SHIP_RADIUS = 10      'Distance from center of triangle to any vertex

Dim mlngTimer As Long       'Holds system time since last frame was displayed
Dim mlngElapsed As Long     'MS of elapsed time since last frame
Dim mlngFrameTimer As Long  'Stores the time since the last FPS display
Dim mintFPS As Long         'An FPS storage variable
Dim mintFPSCounter As Long  'An FPS counter
Dim msngFacing As Single    'Angle the ship is facing (ok, ok, it's a triangle, not a ship! Shut it!)
Dim msngHeading As Single   'Current direction in which ship is moving
Dim msngSpeed As Single     'Current speed with which ship is moving
Dim msngX As Single         'Current X coordinate of ship within form
Dim msngY As Single         'Current Y coordinate of ship within form
Dim mblnRunning As Boolean  'Is the render loop running?
Dim mblnLeftKey As Boolean  'Is the left arrow-key depressed?
Dim mblnRightKey As Boolean 'Is the right arrow-key depressed?
Dim mblnUpKey As Boolean    'Is the up arrow-key depressed?

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)

    'Check for keypresses
    If KeyCode = vbKeyLeft And Not mblnRightKey Then mblnLeftKey = True
    If KeyCode = vbKeyRight And Not mblnLeftKey Then mblnRightKey = True
    If KeyCode = vbKeyUp Then mblnUpKey = True

End Sub

Private Sub Form_KeyUp(KeyCode As Integer, Shift As Integer)

    'Check for keyreleases
    If KeyCode = vbKeyLeft Then mblnLeftKey = False
    If KeyCode = vbKeyRight Then mblnRightKey = False
    If KeyCode = vbKeyUp Then mblnUpKey = False

End Sub

Private Sub Form_Load()

    'Initialize the variables
    msngX = frmShip.ScaleWidth / 2
    msngY = frmShip.ScaleHeight / 2
    msngFacing = 0
    msngSpeed = 0
    msngHeading = 0
    mlngTimer = GetTickCount()
    mblnRunning = True
    
    'Display the form
    frmShip.Show
    
    'Start the render loop
    Do While mblnRunning
        Timer                       'Find the elapsed time, and check FPS
        Physics                     'Allow the ship's location to be updated
        DrawShip                    'Draw the ship
        DoEvents                    'Allow other events to occur
    Loop

    'Unload the form
    Unload Me

End Sub

Private Sub Timer()

    'Determine the time that has elapsed since the last frame was displayed
    mlngElapsed = GetTickCount() - mlngTimer
    'Reset the general timer
    mlngTimer = GetTickCount()
    'Check if one second has elapsed
    If GetTickCount() - mlngFrameTimer >= 1000 Then
        'Set the FPS storage var, and reset the FPS counter/timer
        mintFPS = mintFPSCounter + 1
        mintFPSCounter = 0
        mlngFrameTimer = GetTickCount()
    Else
        'If a second hasn't elapsed, add to the FPS counter
        mintFPSCounter = mintFPSCounter + 1
    End If
    'Show the FPS
    frmShip.Caption = "FPS: " & mintFPS

End Sub

Private Sub Physics()

Dim sngXComp As Single  'Resultant X and Y components
Dim sngYComp As Single

    'Rotate right (take into account the elapsed time)
    If mblnRightKey Then
        msngFacing = msngFacing + (ROTATION_RATE * mlngElapsed) * PI / 180
    End If

    'Rotate left (take into account the elapsed time)
    If mblnLeftKey Then
        msngFacing = msngFacing - (ROTATION_RATE * mlngElapsed) * PI / 180
    End If
    
    'Thrust (take into account the elapsed time)
    If mblnUpKey Then
        AddVectors msngSpeed, msngHeading, ACCEL * mlngElapsed, msngFacing, msngSpeed, msngHeading
    End If
    
    'Adjust coordinates w.r.t. speed (take into account the elapsed time)
    msngX = msngX + (msngSpeed * mlngElapsed) * Sin(msngHeading)
    msngY = msngY - (msngSpeed * mlngElapsed) * Cos(msngHeading)
    
    'Ensure that the ship is visible in the form (wrap edges)
    If msngX > frmShip.ScaleWidth Then msngX = 0
    If msngY > frmShip.ScaleHeight Then msngY = 0
    If msngX < 0 Then msngX = frmShip.ScaleWidth
    If msngY < 0 Then msngY = frmShip.ScaleHeight

End Sub

Private Sub DrawShip()

Dim intX1 As Integer    'Coordinates of the 3 triangle verticies
Dim intY1 As Integer
Dim intX2 As Integer
Dim intY2 As Integer
Dim intX3 As Integer
Dim intY3 As Integer
    
    'Calculate the new ship vertices
    intX1 = msngX + SHIP_RADIUS * Sin(msngFacing)
    intY1 = msngY - SHIP_RADIUS * Cos(msngFacing)
    intX2 = msngX + SHIP_RADIUS * Sin(msngFacing + 2 * PI / 3)
    intY2 = msngY - SHIP_RADIUS * Cos(msngFacing + 2 * PI / 3)
    intX3 = msngX + SHIP_RADIUS * Sin(msngFacing + 4 * PI / 3)
    intY3 = msngY - SHIP_RADIUS * Cos(msngFacing + 4 * PI / 3)
    
    'Clear the form
    frmShip.Cls
    
    'Assign the vertices to the three lines drawn on the form
    Line (intX1, intY1)-(intX2, intY2), vbRed
    Line (intX2, intY2)-(intX3, intY3), vbWhite
    Line (intX3, intY3)-(intX1, intY1), vbRed
        
End Sub

Private Sub Form_Unload(Cancel As Integer)

    'End the program
    mblnRunning = False

End Sub

Private Sub AddVectors(sngMag1 As Single, sngDir1 As Single, sngMag2 As Single, sngDir2 As Single, Optional ByRef sngMagResult As Single, Optional ByRef sngDirResult As Single)

Dim sngXComp As Single
Dim sngYComp As Single
     
    'Determine the components of the resultant vector
    sngXComp = sngMag1 * Sin(sngDir1) + sngMag2 * Sin(sngDir2)
    sngYComp = sngMag1 * Cos(sngDir1) + sngMag2 * Cos(sngDir2)
    'Determine the resultant magnitude
    sngMagResult = Sqr(sngXComp ^ 2 + sngYComp ^ 2)
    'Calculate the resultant direction, and adjust for arctangent by adding Pi if necessary
    If Sgn(sngYComp) > 0 Then sngDirResult = Atn(sngXComp / sngYComp)
    If Sgn(sngYComp) < 0 Then sngDirResult = Atn(sngXComp / sngYComp) + PI

End Sub
